#ifndef _H_F6E103BBFEF0DFCACFFE966258080122_AddSubmap__H_
#define _H_F6E103BBFEF0DFCACFFE966258080122_AddSubmap__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            struct  AddSubmap_Request_
            {
                ::DDS::String_mgr filename_;
            };

            typedef DDS_DCPSStruct_var<AddSubmap_Request_> AddSubmap_Request__var;
            typedef DDS_DCPSStruct_out < AddSubmap_Request_> AddSubmap_Request__out;

            struct  AddSubmap_Response_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<AddSubmap_Response_> AddSubmap_Response__var;
            typedef AddSubmap_Response_& AddSubmap_Response__out;

            struct  Sample_AddSubmap_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::AddSubmap_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddSubmap_Request_> Sample_AddSubmap_Request__var;
            typedef DDS_DCPSStruct_out < Sample_AddSubmap_Request_> Sample_AddSubmap_Request__out;

            struct  Sample_AddSubmap_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::AddSubmap_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddSubmap_Response_> Sample_AddSubmap_Response__var;
            typedef Sample_AddSubmap_Response_& Sample_AddSubmap_Response__out;

        }

    }

}

#endif /* _H_F6E103BBFEF0DFCACFFE966258080122_AddSubmap__H_ */
