#ifndef _H_C22100C118246AA45897BA28971298EC_MergeMaps__H_
#define _H_C22100C118246AA45897BA28971298EC_MergeMaps__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            struct  MergeMaps_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<MergeMaps_Request_> MergeMaps_Request__var;
            typedef MergeMaps_Request_& MergeMaps_Request__out;

            struct  MergeMaps_Response_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<MergeMaps_Response_> MergeMaps_Response__var;
            typedef MergeMaps_Response_& MergeMaps_Response__out;

            struct  Sample_MergeMaps_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::MergeMaps_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_MergeMaps_Request_> Sample_MergeMaps_Request__var;
            typedef Sample_MergeMaps_Request_& Sample_MergeMaps_Request__out;

            struct  Sample_MergeMaps_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::MergeMaps_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_MergeMaps_Response_> Sample_MergeMaps_Response__var;
            typedef Sample_MergeMaps_Response_& Sample_MergeMaps_Response__out;

        }

    }

}

#endif /* _H_C22100C118246AA45897BA28971298EC_MergeMaps__H_ */
