#ifndef _H_3E6936C6ADB392E30FB27AFB003073EB_Pause_DCPS_H_
#define _H_3E6936C6ADB392E30FB27AFB003073EB_Pause_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Pause_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            class Pause_Request_TypeSupportInterface;

            typedef Pause_Request_TypeSupportInterface * Pause_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Pause_Request_TypeSupportInterface> Pause_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Pause_Request_TypeSupportInterface> Pause_Request_TypeSupportInterface_out;


            class Pause_Request_DataWriter;

            typedef Pause_Request_DataWriter * Pause_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Pause_Request_DataWriter> Pause_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Pause_Request_DataWriter> Pause_Request_DataWriter_out;


            class Pause_Request_DataReader;

            typedef Pause_Request_DataReader * Pause_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Pause_Request_DataReader> Pause_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Pause_Request_DataReader> Pause_Request_DataReader_out;


            class Pause_Request_DataReaderView;

            typedef Pause_Request_DataReaderView * Pause_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Pause_Request_DataReaderView> Pause_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Pause_Request_DataReaderView> Pause_Request_DataReaderView_out;

            struct Pause_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Pause_Request_, struct Pause_Request_Seq_uniq_> Pause_Request_Seq;
            typedef DDS_DCPSSequence_var < Pause_Request_Seq> Pause_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Pause_Request_Seq> Pause_Request_Seq_out;

            class  Pause_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Pause_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Pause_Request_TypeSupportInterface_var _var_type;

                static Pause_Request_TypeSupportInterface_ptr _duplicate (Pause_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Pause_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Pause_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Pause_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Pause_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Pause_Request_TypeSupportInterface () {};
                ~Pause_Request_TypeSupportInterface () {};
            private:
                Pause_Request_TypeSupportInterface (const Pause_Request_TypeSupportInterface &);
                Pause_Request_TypeSupportInterface & operator = (const Pause_Request_TypeSupportInterface &);
            };

            class  Pause_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Pause_Request_DataWriter_ptr _ptr_type;
                typedef Pause_Request_DataWriter_var _var_type;

                static Pause_Request_DataWriter_ptr _duplicate (Pause_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Pause_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Pause_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Pause_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Pause_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Pause_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Pause_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Pause_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Pause_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Pause_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Pause_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Pause_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Pause_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Pause_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Pause_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Pause_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Pause_Request_& instance_data) = 0;

            protected:
                Pause_Request_DataWriter () {};
                ~Pause_Request_DataWriter () {};
            private:
                Pause_Request_DataWriter (const Pause_Request_DataWriter &);
                Pause_Request_DataWriter & operator = (const Pause_Request_DataWriter &);
            };

            class  Pause_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Pause_Request_DataReader_ptr _ptr_type;
                typedef Pause_Request_DataReader_var _var_type;

                static Pause_Request_DataReader_ptr _duplicate (Pause_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Pause_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Pause_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Pause_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Pause_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Pause_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Pause_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Pause_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Pause_Request_& instance) = 0;

            protected:
                Pause_Request_DataReader () {};
                ~Pause_Request_DataReader () {};
            private:
                Pause_Request_DataReader (const Pause_Request_DataReader &);
                Pause_Request_DataReader & operator = (const Pause_Request_DataReader &);
            };

            class  Pause_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Pause_Request_DataReaderView_ptr _ptr_type;
                typedef Pause_Request_DataReaderView_var _var_type;

                static Pause_Request_DataReaderView_ptr _duplicate (Pause_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Pause_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Pause_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Pause_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Pause_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Pause_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Pause_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Pause_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Pause_Request_& instance) = 0;

            protected:
                Pause_Request_DataReaderView () {};
                ~Pause_Request_DataReaderView () {};
            private:
                Pause_Request_DataReaderView (const Pause_Request_DataReaderView &);
                Pause_Request_DataReaderView & operator = (const Pause_Request_DataReaderView &);
            };
            class Pause_Response_TypeSupportInterface;

            typedef Pause_Response_TypeSupportInterface * Pause_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Pause_Response_TypeSupportInterface> Pause_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Pause_Response_TypeSupportInterface> Pause_Response_TypeSupportInterface_out;


            class Pause_Response_DataWriter;

            typedef Pause_Response_DataWriter * Pause_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Pause_Response_DataWriter> Pause_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Pause_Response_DataWriter> Pause_Response_DataWriter_out;


            class Pause_Response_DataReader;

            typedef Pause_Response_DataReader * Pause_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Pause_Response_DataReader> Pause_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Pause_Response_DataReader> Pause_Response_DataReader_out;


            class Pause_Response_DataReaderView;

            typedef Pause_Response_DataReaderView * Pause_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Pause_Response_DataReaderView> Pause_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Pause_Response_DataReaderView> Pause_Response_DataReaderView_out;

            struct Pause_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Pause_Response_, struct Pause_Response_Seq_uniq_> Pause_Response_Seq;
            typedef DDS_DCPSSequence_var < Pause_Response_Seq> Pause_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Pause_Response_Seq> Pause_Response_Seq_out;

            class  Pause_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Pause_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Pause_Response_TypeSupportInterface_var _var_type;

                static Pause_Response_TypeSupportInterface_ptr _duplicate (Pause_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Pause_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Pause_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Pause_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Pause_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Pause_Response_TypeSupportInterface () {};
                ~Pause_Response_TypeSupportInterface () {};
            private:
                Pause_Response_TypeSupportInterface (const Pause_Response_TypeSupportInterface &);
                Pause_Response_TypeSupportInterface & operator = (const Pause_Response_TypeSupportInterface &);
            };

            class  Pause_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Pause_Response_DataWriter_ptr _ptr_type;
                typedef Pause_Response_DataWriter_var _var_type;

                static Pause_Response_DataWriter_ptr _duplicate (Pause_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Pause_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Pause_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Pause_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Pause_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Pause_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Pause_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Pause_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Pause_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Pause_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Pause_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Pause_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Pause_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Pause_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Pause_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Pause_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Pause_Response_& instance_data) = 0;

            protected:
                Pause_Response_DataWriter () {};
                ~Pause_Response_DataWriter () {};
            private:
                Pause_Response_DataWriter (const Pause_Response_DataWriter &);
                Pause_Response_DataWriter & operator = (const Pause_Response_DataWriter &);
            };

            class  Pause_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Pause_Response_DataReader_ptr _ptr_type;
                typedef Pause_Response_DataReader_var _var_type;

                static Pause_Response_DataReader_ptr _duplicate (Pause_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Pause_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Pause_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Pause_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Pause_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Pause_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Pause_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Pause_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Pause_Response_& instance) = 0;

            protected:
                Pause_Response_DataReader () {};
                ~Pause_Response_DataReader () {};
            private:
                Pause_Response_DataReader (const Pause_Response_DataReader &);
                Pause_Response_DataReader & operator = (const Pause_Response_DataReader &);
            };

            class  Pause_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Pause_Response_DataReaderView_ptr _ptr_type;
                typedef Pause_Response_DataReaderView_var _var_type;

                static Pause_Response_DataReaderView_ptr _duplicate (Pause_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Pause_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Pause_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Pause_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Pause_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Pause_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Pause_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Pause_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Pause_Response_& instance) = 0;

            protected:
                Pause_Response_DataReaderView () {};
                ~Pause_Response_DataReaderView () {};
            private:
                Pause_Response_DataReaderView (const Pause_Response_DataReaderView &);
                Pause_Response_DataReaderView & operator = (const Pause_Response_DataReaderView &);
            };
            class Sample_Pause_Request_TypeSupportInterface;

            typedef Sample_Pause_Request_TypeSupportInterface * Sample_Pause_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Pause_Request_TypeSupportInterface> Sample_Pause_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Pause_Request_TypeSupportInterface> Sample_Pause_Request_TypeSupportInterface_out;


            class Sample_Pause_Request_DataWriter;

            typedef Sample_Pause_Request_DataWriter * Sample_Pause_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Pause_Request_DataWriter> Sample_Pause_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Pause_Request_DataWriter> Sample_Pause_Request_DataWriter_out;


            class Sample_Pause_Request_DataReader;

            typedef Sample_Pause_Request_DataReader * Sample_Pause_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Pause_Request_DataReader> Sample_Pause_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Pause_Request_DataReader> Sample_Pause_Request_DataReader_out;


            class Sample_Pause_Request_DataReaderView;

            typedef Sample_Pause_Request_DataReaderView * Sample_Pause_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Pause_Request_DataReaderView> Sample_Pause_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Pause_Request_DataReaderView> Sample_Pause_Request_DataReaderView_out;

            struct Sample_Pause_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Pause_Request_, struct Sample_Pause_Request_Seq_uniq_> Sample_Pause_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Pause_Request_Seq> Sample_Pause_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Pause_Request_Seq> Sample_Pause_Request_Seq_out;

            class  Sample_Pause_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Pause_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Pause_Request_TypeSupportInterface_var _var_type;

                static Sample_Pause_Request_TypeSupportInterface_ptr _duplicate (Sample_Pause_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Pause_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Pause_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Pause_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Pause_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Pause_Request_TypeSupportInterface () {};
                ~Sample_Pause_Request_TypeSupportInterface () {};
            private:
                Sample_Pause_Request_TypeSupportInterface (const Sample_Pause_Request_TypeSupportInterface &);
                Sample_Pause_Request_TypeSupportInterface & operator = (const Sample_Pause_Request_TypeSupportInterface &);
            };

            class  Sample_Pause_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Pause_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Pause_Request_DataWriter_var _var_type;

                static Sample_Pause_Request_DataWriter_ptr _duplicate (Sample_Pause_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Pause_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Pause_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Pause_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Pause_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Pause_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Pause_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Pause_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Pause_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Pause_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Pause_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Pause_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Pause_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Pause_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Pause_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Pause_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Pause_Request_& instance_data) = 0;

            protected:
                Sample_Pause_Request_DataWriter () {};
                ~Sample_Pause_Request_DataWriter () {};
            private:
                Sample_Pause_Request_DataWriter (const Sample_Pause_Request_DataWriter &);
                Sample_Pause_Request_DataWriter & operator = (const Sample_Pause_Request_DataWriter &);
            };

            class  Sample_Pause_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Pause_Request_DataReader_ptr _ptr_type;
                typedef Sample_Pause_Request_DataReader_var _var_type;

                static Sample_Pause_Request_DataReader_ptr _duplicate (Sample_Pause_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Pause_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Pause_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Pause_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Pause_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Pause_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Pause_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Pause_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Pause_Request_& instance) = 0;

            protected:
                Sample_Pause_Request_DataReader () {};
                ~Sample_Pause_Request_DataReader () {};
            private:
                Sample_Pause_Request_DataReader (const Sample_Pause_Request_DataReader &);
                Sample_Pause_Request_DataReader & operator = (const Sample_Pause_Request_DataReader &);
            };

            class  Sample_Pause_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Pause_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Pause_Request_DataReaderView_var _var_type;

                static Sample_Pause_Request_DataReaderView_ptr _duplicate (Sample_Pause_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Pause_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Pause_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Pause_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Pause_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Pause_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Pause_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Pause_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Pause_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Pause_Request_& instance) = 0;

            protected:
                Sample_Pause_Request_DataReaderView () {};
                ~Sample_Pause_Request_DataReaderView () {};
            private:
                Sample_Pause_Request_DataReaderView (const Sample_Pause_Request_DataReaderView &);
                Sample_Pause_Request_DataReaderView & operator = (const Sample_Pause_Request_DataReaderView &);
            };
            class Sample_Pause_Response_TypeSupportInterface;

            typedef Sample_Pause_Response_TypeSupportInterface * Sample_Pause_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Pause_Response_TypeSupportInterface> Sample_Pause_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Pause_Response_TypeSupportInterface> Sample_Pause_Response_TypeSupportInterface_out;


            class Sample_Pause_Response_DataWriter;

            typedef Sample_Pause_Response_DataWriter * Sample_Pause_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Pause_Response_DataWriter> Sample_Pause_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Pause_Response_DataWriter> Sample_Pause_Response_DataWriter_out;


            class Sample_Pause_Response_DataReader;

            typedef Sample_Pause_Response_DataReader * Sample_Pause_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Pause_Response_DataReader> Sample_Pause_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Pause_Response_DataReader> Sample_Pause_Response_DataReader_out;


            class Sample_Pause_Response_DataReaderView;

            typedef Sample_Pause_Response_DataReaderView * Sample_Pause_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Pause_Response_DataReaderView> Sample_Pause_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Pause_Response_DataReaderView> Sample_Pause_Response_DataReaderView_out;

            struct Sample_Pause_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Pause_Response_, struct Sample_Pause_Response_Seq_uniq_> Sample_Pause_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Pause_Response_Seq> Sample_Pause_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Pause_Response_Seq> Sample_Pause_Response_Seq_out;

            class  Sample_Pause_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Pause_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Pause_Response_TypeSupportInterface_var _var_type;

                static Sample_Pause_Response_TypeSupportInterface_ptr _duplicate (Sample_Pause_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Pause_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Pause_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Pause_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Pause_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Pause_Response_TypeSupportInterface () {};
                ~Sample_Pause_Response_TypeSupportInterface () {};
            private:
                Sample_Pause_Response_TypeSupportInterface (const Sample_Pause_Response_TypeSupportInterface &);
                Sample_Pause_Response_TypeSupportInterface & operator = (const Sample_Pause_Response_TypeSupportInterface &);
            };

            class  Sample_Pause_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Pause_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Pause_Response_DataWriter_var _var_type;

                static Sample_Pause_Response_DataWriter_ptr _duplicate (Sample_Pause_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Pause_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Pause_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Pause_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Pause_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Pause_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Pause_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Pause_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Pause_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Pause_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Pause_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Pause_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Pause_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Pause_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Pause_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Pause_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Pause_Response_& instance_data) = 0;

            protected:
                Sample_Pause_Response_DataWriter () {};
                ~Sample_Pause_Response_DataWriter () {};
            private:
                Sample_Pause_Response_DataWriter (const Sample_Pause_Response_DataWriter &);
                Sample_Pause_Response_DataWriter & operator = (const Sample_Pause_Response_DataWriter &);
            };

            class  Sample_Pause_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Pause_Response_DataReader_ptr _ptr_type;
                typedef Sample_Pause_Response_DataReader_var _var_type;

                static Sample_Pause_Response_DataReader_ptr _duplicate (Sample_Pause_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Pause_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Pause_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Pause_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Pause_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Pause_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Pause_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Pause_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Pause_Response_& instance) = 0;

            protected:
                Sample_Pause_Response_DataReader () {};
                ~Sample_Pause_Response_DataReader () {};
            private:
                Sample_Pause_Response_DataReader (const Sample_Pause_Response_DataReader &);
                Sample_Pause_Response_DataReader & operator = (const Sample_Pause_Response_DataReader &);
            };

            class  Sample_Pause_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Pause_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Pause_Response_DataReaderView_var _var_type;

                static Sample_Pause_Response_DataReaderView_ptr _duplicate (Sample_Pause_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Pause_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Pause_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Pause_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Pause_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Pause_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Pause_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Pause_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Pause_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Pause_Response_& instance) = 0;

            protected:
                Sample_Pause_Response_DataReaderView () {};
                ~Sample_Pause_Response_DataReaderView () {};
            private:
                Sample_Pause_Response_DataReaderView (const Sample_Pause_Response_DataReaderView &);
                Sample_Pause_Response_DataReaderView & operator = (const Sample_Pause_Response_DataReaderView &);
            };
        }

    }

}

#endif
