#ifndef _H_F95EC80BF10669BD15C6AE9F0443B8BD_SerializePoseGraph__H_
#define _H_F95EC80BF10669BD15C6AE9F0443B8BD_SerializePoseGraph__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            struct  SerializePoseGraph_Request_
            {
                ::DDS::String_mgr filename_;
            };

            typedef DDS_DCPSStruct_var<SerializePoseGraph_Request_> SerializePoseGraph_Request__var;
            typedef DDS_DCPSStruct_out < SerializePoseGraph_Request_> SerializePoseGraph_Request__out;

            struct  SerializePoseGraph_Response_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<SerializePoseGraph_Response_> SerializePoseGraph_Response__var;
            typedef SerializePoseGraph_Response_& SerializePoseGraph_Response__out;

            struct  Sample_SerializePoseGraph_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::SerializePoseGraph_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SerializePoseGraph_Request_> Sample_SerializePoseGraph_Request__var;
            typedef DDS_DCPSStruct_out < Sample_SerializePoseGraph_Request_> Sample_SerializePoseGraph_Request__out;

            struct  Sample_SerializePoseGraph_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::SerializePoseGraph_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SerializePoseGraph_Response_> Sample_SerializePoseGraph_Response__var;
            typedef Sample_SerializePoseGraph_Response_& Sample_SerializePoseGraph_Response__out;

        }

    }

}

#endif /* _H_F95EC80BF10669BD15C6AE9F0443B8BD_SerializePoseGraph__H_ */
