#ifndef _H_034957473F4A2A2DDB62BCF92EF7B7AA_ToggleInteractive__H_
#define _H_034957473F4A2A2DDB62BCF92EF7B7AA_ToggleInteractive__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            struct  ToggleInteractive_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<ToggleInteractive_Request_> ToggleInteractive_Request__var;
            typedef ToggleInteractive_Request_& ToggleInteractive_Request__out;

            struct  ToggleInteractive_Response_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<ToggleInteractive_Response_> ToggleInteractive_Response__var;
            typedef ToggleInteractive_Response_& ToggleInteractive_Response__out;

            struct  Sample_ToggleInteractive_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::ToggleInteractive_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ToggleInteractive_Request_> Sample_ToggleInteractive_Request__var;
            typedef Sample_ToggleInteractive_Request_& Sample_ToggleInteractive_Request__out;

            struct  Sample_ToggleInteractive_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::ToggleInteractive_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ToggleInteractive_Response_> Sample_ToggleInteractive_Response__var;
            typedef Sample_ToggleInteractive_Response_& Sample_ToggleInteractive_Response__out;

        }

    }

}

#endif /* _H_034957473F4A2A2DDB62BCF92EF7B7AA_ToggleInteractive__H_ */
