#ifndef _H_F6E103BBFEF0DFCACFFE966258080122_AddSubmap_DCPS_H_
#define _H_F6E103BBFEF0DFCACFFE966258080122_AddSubmap_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AddSubmap_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            class AddSubmap_Request_TypeSupportInterface;

            typedef AddSubmap_Request_TypeSupportInterface * AddSubmap_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddSubmap_Request_TypeSupportInterface> AddSubmap_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddSubmap_Request_TypeSupportInterface> AddSubmap_Request_TypeSupportInterface_out;


            class AddSubmap_Request_DataWriter;

            typedef AddSubmap_Request_DataWriter * AddSubmap_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddSubmap_Request_DataWriter> AddSubmap_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddSubmap_Request_DataWriter> AddSubmap_Request_DataWriter_out;


            class AddSubmap_Request_DataReader;

            typedef AddSubmap_Request_DataReader * AddSubmap_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddSubmap_Request_DataReader> AddSubmap_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AddSubmap_Request_DataReader> AddSubmap_Request_DataReader_out;


            class AddSubmap_Request_DataReaderView;

            typedef AddSubmap_Request_DataReaderView * AddSubmap_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddSubmap_Request_DataReaderView> AddSubmap_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddSubmap_Request_DataReaderView> AddSubmap_Request_DataReaderView_out;

            struct AddSubmap_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddSubmap_Request_, struct AddSubmap_Request_Seq_uniq_> AddSubmap_Request_Seq;
            typedef DDS_DCPSSequence_var < AddSubmap_Request_Seq> AddSubmap_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AddSubmap_Request_Seq> AddSubmap_Request_Seq_out;

            class  AddSubmap_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddSubmap_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AddSubmap_Request_TypeSupportInterface_var _var_type;

                static AddSubmap_Request_TypeSupportInterface_ptr _duplicate (AddSubmap_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddSubmap_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddSubmap_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddSubmap_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddSubmap_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddSubmap_Request_TypeSupportInterface () {};
                ~AddSubmap_Request_TypeSupportInterface () {};
            private:
                AddSubmap_Request_TypeSupportInterface (const AddSubmap_Request_TypeSupportInterface &);
                AddSubmap_Request_TypeSupportInterface & operator = (const AddSubmap_Request_TypeSupportInterface &);
            };

            class  AddSubmap_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddSubmap_Request_DataWriter_ptr _ptr_type;
                typedef AddSubmap_Request_DataWriter_var _var_type;

                static AddSubmap_Request_DataWriter_ptr _duplicate (AddSubmap_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddSubmap_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddSubmap_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddSubmap_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddSubmap_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddSubmap_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddSubmap_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddSubmap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddSubmap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddSubmap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddSubmap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddSubmap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddSubmap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddSubmap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddSubmap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddSubmap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddSubmap_Request_& instance_data) = 0;

            protected:
                AddSubmap_Request_DataWriter () {};
                ~AddSubmap_Request_DataWriter () {};
            private:
                AddSubmap_Request_DataWriter (const AddSubmap_Request_DataWriter &);
                AddSubmap_Request_DataWriter & operator = (const AddSubmap_Request_DataWriter &);
            };

            class  AddSubmap_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddSubmap_Request_DataReader_ptr _ptr_type;
                typedef AddSubmap_Request_DataReader_var _var_type;

                static AddSubmap_Request_DataReader_ptr _duplicate (AddSubmap_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddSubmap_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddSubmap_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddSubmap_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddSubmap_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddSubmap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddSubmap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddSubmap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddSubmap_Request_& instance) = 0;

            protected:
                AddSubmap_Request_DataReader () {};
                ~AddSubmap_Request_DataReader () {};
            private:
                AddSubmap_Request_DataReader (const AddSubmap_Request_DataReader &);
                AddSubmap_Request_DataReader & operator = (const AddSubmap_Request_DataReader &);
            };

            class  AddSubmap_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddSubmap_Request_DataReaderView_ptr _ptr_type;
                typedef AddSubmap_Request_DataReaderView_var _var_type;

                static AddSubmap_Request_DataReaderView_ptr _duplicate (AddSubmap_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddSubmap_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddSubmap_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddSubmap_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddSubmap_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddSubmap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddSubmap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddSubmap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddSubmap_Request_& instance) = 0;

            protected:
                AddSubmap_Request_DataReaderView () {};
                ~AddSubmap_Request_DataReaderView () {};
            private:
                AddSubmap_Request_DataReaderView (const AddSubmap_Request_DataReaderView &);
                AddSubmap_Request_DataReaderView & operator = (const AddSubmap_Request_DataReaderView &);
            };
            class AddSubmap_Response_TypeSupportInterface;

            typedef AddSubmap_Response_TypeSupportInterface * AddSubmap_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddSubmap_Response_TypeSupportInterface> AddSubmap_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddSubmap_Response_TypeSupportInterface> AddSubmap_Response_TypeSupportInterface_out;


            class AddSubmap_Response_DataWriter;

            typedef AddSubmap_Response_DataWriter * AddSubmap_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddSubmap_Response_DataWriter> AddSubmap_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddSubmap_Response_DataWriter> AddSubmap_Response_DataWriter_out;


            class AddSubmap_Response_DataReader;

            typedef AddSubmap_Response_DataReader * AddSubmap_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddSubmap_Response_DataReader> AddSubmap_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AddSubmap_Response_DataReader> AddSubmap_Response_DataReader_out;


            class AddSubmap_Response_DataReaderView;

            typedef AddSubmap_Response_DataReaderView * AddSubmap_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddSubmap_Response_DataReaderView> AddSubmap_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddSubmap_Response_DataReaderView> AddSubmap_Response_DataReaderView_out;

            struct AddSubmap_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AddSubmap_Response_, struct AddSubmap_Response_Seq_uniq_> AddSubmap_Response_Seq;
            typedef DDS_DCPSSequence_var < AddSubmap_Response_Seq> AddSubmap_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AddSubmap_Response_Seq> AddSubmap_Response_Seq_out;

            class  AddSubmap_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddSubmap_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AddSubmap_Response_TypeSupportInterface_var _var_type;

                static AddSubmap_Response_TypeSupportInterface_ptr _duplicate (AddSubmap_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddSubmap_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddSubmap_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddSubmap_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddSubmap_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddSubmap_Response_TypeSupportInterface () {};
                ~AddSubmap_Response_TypeSupportInterface () {};
            private:
                AddSubmap_Response_TypeSupportInterface (const AddSubmap_Response_TypeSupportInterface &);
                AddSubmap_Response_TypeSupportInterface & operator = (const AddSubmap_Response_TypeSupportInterface &);
            };

            class  AddSubmap_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddSubmap_Response_DataWriter_ptr _ptr_type;
                typedef AddSubmap_Response_DataWriter_var _var_type;

                static AddSubmap_Response_DataWriter_ptr _duplicate (AddSubmap_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddSubmap_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddSubmap_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddSubmap_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddSubmap_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddSubmap_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddSubmap_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddSubmap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddSubmap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddSubmap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddSubmap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddSubmap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddSubmap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddSubmap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddSubmap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddSubmap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddSubmap_Response_& instance_data) = 0;

            protected:
                AddSubmap_Response_DataWriter () {};
                ~AddSubmap_Response_DataWriter () {};
            private:
                AddSubmap_Response_DataWriter (const AddSubmap_Response_DataWriter &);
                AddSubmap_Response_DataWriter & operator = (const AddSubmap_Response_DataWriter &);
            };

            class  AddSubmap_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddSubmap_Response_DataReader_ptr _ptr_type;
                typedef AddSubmap_Response_DataReader_var _var_type;

                static AddSubmap_Response_DataReader_ptr _duplicate (AddSubmap_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddSubmap_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddSubmap_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddSubmap_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddSubmap_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddSubmap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddSubmap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddSubmap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddSubmap_Response_& instance) = 0;

            protected:
                AddSubmap_Response_DataReader () {};
                ~AddSubmap_Response_DataReader () {};
            private:
                AddSubmap_Response_DataReader (const AddSubmap_Response_DataReader &);
                AddSubmap_Response_DataReader & operator = (const AddSubmap_Response_DataReader &);
            };

            class  AddSubmap_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddSubmap_Response_DataReaderView_ptr _ptr_type;
                typedef AddSubmap_Response_DataReaderView_var _var_type;

                static AddSubmap_Response_DataReaderView_ptr _duplicate (AddSubmap_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddSubmap_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddSubmap_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddSubmap_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddSubmap_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddSubmap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddSubmap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddSubmap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddSubmap_Response_& instance) = 0;

            protected:
                AddSubmap_Response_DataReaderView () {};
                ~AddSubmap_Response_DataReaderView () {};
            private:
                AddSubmap_Response_DataReaderView (const AddSubmap_Response_DataReaderView &);
                AddSubmap_Response_DataReaderView & operator = (const AddSubmap_Response_DataReaderView &);
            };
            class Sample_AddSubmap_Request_TypeSupportInterface;

            typedef Sample_AddSubmap_Request_TypeSupportInterface * Sample_AddSubmap_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddSubmap_Request_TypeSupportInterface> Sample_AddSubmap_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddSubmap_Request_TypeSupportInterface> Sample_AddSubmap_Request_TypeSupportInterface_out;


            class Sample_AddSubmap_Request_DataWriter;

            typedef Sample_AddSubmap_Request_DataWriter * Sample_AddSubmap_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddSubmap_Request_DataWriter> Sample_AddSubmap_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddSubmap_Request_DataWriter> Sample_AddSubmap_Request_DataWriter_out;


            class Sample_AddSubmap_Request_DataReader;

            typedef Sample_AddSubmap_Request_DataReader * Sample_AddSubmap_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddSubmap_Request_DataReader> Sample_AddSubmap_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddSubmap_Request_DataReader> Sample_AddSubmap_Request_DataReader_out;


            class Sample_AddSubmap_Request_DataReaderView;

            typedef Sample_AddSubmap_Request_DataReaderView * Sample_AddSubmap_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddSubmap_Request_DataReaderView> Sample_AddSubmap_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddSubmap_Request_DataReaderView> Sample_AddSubmap_Request_DataReaderView_out;

            struct Sample_AddSubmap_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddSubmap_Request_, struct Sample_AddSubmap_Request_Seq_uniq_> Sample_AddSubmap_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddSubmap_Request_Seq> Sample_AddSubmap_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddSubmap_Request_Seq> Sample_AddSubmap_Request_Seq_out;

            class  Sample_AddSubmap_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddSubmap_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddSubmap_Request_TypeSupportInterface_var _var_type;

                static Sample_AddSubmap_Request_TypeSupportInterface_ptr _duplicate (Sample_AddSubmap_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddSubmap_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddSubmap_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddSubmap_Request_TypeSupportInterface () {};
                ~Sample_AddSubmap_Request_TypeSupportInterface () {};
            private:
                Sample_AddSubmap_Request_TypeSupportInterface (const Sample_AddSubmap_Request_TypeSupportInterface &);
                Sample_AddSubmap_Request_TypeSupportInterface & operator = (const Sample_AddSubmap_Request_TypeSupportInterface &);
            };

            class  Sample_AddSubmap_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddSubmap_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AddSubmap_Request_DataWriter_var _var_type;

                static Sample_AddSubmap_Request_DataWriter_ptr _duplicate (Sample_AddSubmap_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddSubmap_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddSubmap_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddSubmap_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddSubmap_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddSubmap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddSubmap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddSubmap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddSubmap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddSubmap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddSubmap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddSubmap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddSubmap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddSubmap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddSubmap_Request_& instance_data) = 0;

            protected:
                Sample_AddSubmap_Request_DataWriter () {};
                ~Sample_AddSubmap_Request_DataWriter () {};
            private:
                Sample_AddSubmap_Request_DataWriter (const Sample_AddSubmap_Request_DataWriter &);
                Sample_AddSubmap_Request_DataWriter & operator = (const Sample_AddSubmap_Request_DataWriter &);
            };

            class  Sample_AddSubmap_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddSubmap_Request_DataReader_ptr _ptr_type;
                typedef Sample_AddSubmap_Request_DataReader_var _var_type;

                static Sample_AddSubmap_Request_DataReader_ptr _duplicate (Sample_AddSubmap_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddSubmap_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddSubmap_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddSubmap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddSubmap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddSubmap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddSubmap_Request_& instance) = 0;

            protected:
                Sample_AddSubmap_Request_DataReader () {};
                ~Sample_AddSubmap_Request_DataReader () {};
            private:
                Sample_AddSubmap_Request_DataReader (const Sample_AddSubmap_Request_DataReader &);
                Sample_AddSubmap_Request_DataReader & operator = (const Sample_AddSubmap_Request_DataReader &);
            };

            class  Sample_AddSubmap_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddSubmap_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AddSubmap_Request_DataReaderView_var _var_type;

                static Sample_AddSubmap_Request_DataReaderView_ptr _duplicate (Sample_AddSubmap_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddSubmap_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddSubmap_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddSubmap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddSubmap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddSubmap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddSubmap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddSubmap_Request_& instance) = 0;

            protected:
                Sample_AddSubmap_Request_DataReaderView () {};
                ~Sample_AddSubmap_Request_DataReaderView () {};
            private:
                Sample_AddSubmap_Request_DataReaderView (const Sample_AddSubmap_Request_DataReaderView &);
                Sample_AddSubmap_Request_DataReaderView & operator = (const Sample_AddSubmap_Request_DataReaderView &);
            };
            class Sample_AddSubmap_Response_TypeSupportInterface;

            typedef Sample_AddSubmap_Response_TypeSupportInterface * Sample_AddSubmap_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddSubmap_Response_TypeSupportInterface> Sample_AddSubmap_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddSubmap_Response_TypeSupportInterface> Sample_AddSubmap_Response_TypeSupportInterface_out;


            class Sample_AddSubmap_Response_DataWriter;

            typedef Sample_AddSubmap_Response_DataWriter * Sample_AddSubmap_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddSubmap_Response_DataWriter> Sample_AddSubmap_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddSubmap_Response_DataWriter> Sample_AddSubmap_Response_DataWriter_out;


            class Sample_AddSubmap_Response_DataReader;

            typedef Sample_AddSubmap_Response_DataReader * Sample_AddSubmap_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddSubmap_Response_DataReader> Sample_AddSubmap_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddSubmap_Response_DataReader> Sample_AddSubmap_Response_DataReader_out;


            class Sample_AddSubmap_Response_DataReaderView;

            typedef Sample_AddSubmap_Response_DataReaderView * Sample_AddSubmap_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddSubmap_Response_DataReaderView> Sample_AddSubmap_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddSubmap_Response_DataReaderView> Sample_AddSubmap_Response_DataReaderView_out;

            struct Sample_AddSubmap_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_AddSubmap_Response_, struct Sample_AddSubmap_Response_Seq_uniq_> Sample_AddSubmap_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddSubmap_Response_Seq> Sample_AddSubmap_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddSubmap_Response_Seq> Sample_AddSubmap_Response_Seq_out;

            class  Sample_AddSubmap_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddSubmap_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddSubmap_Response_TypeSupportInterface_var _var_type;

                static Sample_AddSubmap_Response_TypeSupportInterface_ptr _duplicate (Sample_AddSubmap_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddSubmap_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddSubmap_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddSubmap_Response_TypeSupportInterface () {};
                ~Sample_AddSubmap_Response_TypeSupportInterface () {};
            private:
                Sample_AddSubmap_Response_TypeSupportInterface (const Sample_AddSubmap_Response_TypeSupportInterface &);
                Sample_AddSubmap_Response_TypeSupportInterface & operator = (const Sample_AddSubmap_Response_TypeSupportInterface &);
            };

            class  Sample_AddSubmap_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddSubmap_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AddSubmap_Response_DataWriter_var _var_type;

                static Sample_AddSubmap_Response_DataWriter_ptr _duplicate (Sample_AddSubmap_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddSubmap_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddSubmap_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddSubmap_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddSubmap_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddSubmap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddSubmap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddSubmap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddSubmap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddSubmap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddSubmap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddSubmap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddSubmap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddSubmap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddSubmap_Response_& instance_data) = 0;

            protected:
                Sample_AddSubmap_Response_DataWriter () {};
                ~Sample_AddSubmap_Response_DataWriter () {};
            private:
                Sample_AddSubmap_Response_DataWriter (const Sample_AddSubmap_Response_DataWriter &);
                Sample_AddSubmap_Response_DataWriter & operator = (const Sample_AddSubmap_Response_DataWriter &);
            };

            class  Sample_AddSubmap_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddSubmap_Response_DataReader_ptr _ptr_type;
                typedef Sample_AddSubmap_Response_DataReader_var _var_type;

                static Sample_AddSubmap_Response_DataReader_ptr _duplicate (Sample_AddSubmap_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddSubmap_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddSubmap_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddSubmap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddSubmap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddSubmap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddSubmap_Response_& instance) = 0;

            protected:
                Sample_AddSubmap_Response_DataReader () {};
                ~Sample_AddSubmap_Response_DataReader () {};
            private:
                Sample_AddSubmap_Response_DataReader (const Sample_AddSubmap_Response_DataReader &);
                Sample_AddSubmap_Response_DataReader & operator = (const Sample_AddSubmap_Response_DataReader &);
            };

            class  Sample_AddSubmap_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddSubmap_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AddSubmap_Response_DataReaderView_var _var_type;

                static Sample_AddSubmap_Response_DataReaderView_ptr _duplicate (Sample_AddSubmap_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddSubmap_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddSubmap_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddSubmap_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddSubmap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddSubmap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddSubmap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddSubmap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddSubmap_Response_& instance) = 0;

            protected:
                Sample_AddSubmap_Response_DataReaderView () {};
                ~Sample_AddSubmap_Response_DataReaderView () {};
            private:
                Sample_AddSubmap_Response_DataReaderView (const Sample_AddSubmap_Response_DataReaderView &);
                Sample_AddSubmap_Response_DataReaderView & operator = (const Sample_AddSubmap_Response_DataReaderView &);
            };
        }

    }

}

#endif
