#ifndef _H_14059351A3F3A6DDF6642B2015AE2039_DeserializePoseGraph_DCPS_H_
#define _H_14059351A3F3A6DDF6642B2015AE2039_DeserializePoseGraph_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DeserializePoseGraph_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            class DeserializePoseGraph_Request_TypeSupportInterface;

            typedef DeserializePoseGraph_Request_TypeSupportInterface * DeserializePoseGraph_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeserializePoseGraph_Request_TypeSupportInterface> DeserializePoseGraph_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeserializePoseGraph_Request_TypeSupportInterface> DeserializePoseGraph_Request_TypeSupportInterface_out;


            class DeserializePoseGraph_Request_DataWriter;

            typedef DeserializePoseGraph_Request_DataWriter * DeserializePoseGraph_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeserializePoseGraph_Request_DataWriter> DeserializePoseGraph_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeserializePoseGraph_Request_DataWriter> DeserializePoseGraph_Request_DataWriter_out;


            class DeserializePoseGraph_Request_DataReader;

            typedef DeserializePoseGraph_Request_DataReader * DeserializePoseGraph_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeserializePoseGraph_Request_DataReader> DeserializePoseGraph_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < DeserializePoseGraph_Request_DataReader> DeserializePoseGraph_Request_DataReader_out;


            class DeserializePoseGraph_Request_DataReaderView;

            typedef DeserializePoseGraph_Request_DataReaderView * DeserializePoseGraph_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeserializePoseGraph_Request_DataReaderView> DeserializePoseGraph_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeserializePoseGraph_Request_DataReaderView> DeserializePoseGraph_Request_DataReaderView_out;

            struct DeserializePoseGraph_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DeserializePoseGraph_Request_, struct DeserializePoseGraph_Request_Seq_uniq_> DeserializePoseGraph_Request_Seq;
            typedef DDS_DCPSSequence_var < DeserializePoseGraph_Request_Seq> DeserializePoseGraph_Request_Seq_var;
            typedef DDS_DCPSSequence_out < DeserializePoseGraph_Request_Seq> DeserializePoseGraph_Request_Seq_out;

            class  DeserializePoseGraph_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeserializePoseGraph_Request_TypeSupportInterface_ptr _ptr_type;
                typedef DeserializePoseGraph_Request_TypeSupportInterface_var _var_type;

                static DeserializePoseGraph_Request_TypeSupportInterface_ptr _duplicate (DeserializePoseGraph_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeserializePoseGraph_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeserializePoseGraph_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeserializePoseGraph_Request_TypeSupportInterface () {};
                ~DeserializePoseGraph_Request_TypeSupportInterface () {};
            private:
                DeserializePoseGraph_Request_TypeSupportInterface (const DeserializePoseGraph_Request_TypeSupportInterface &);
                DeserializePoseGraph_Request_TypeSupportInterface & operator = (const DeserializePoseGraph_Request_TypeSupportInterface &);
            };

            class  DeserializePoseGraph_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeserializePoseGraph_Request_DataWriter_ptr _ptr_type;
                typedef DeserializePoseGraph_Request_DataWriter_var _var_type;

                static DeserializePoseGraph_Request_DataWriter_ptr _duplicate (DeserializePoseGraph_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeserializePoseGraph_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeserializePoseGraph_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeserializePoseGraph_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeserializePoseGraph_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeserializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeserializePoseGraph_Request_& instance_data) = 0;

            protected:
                DeserializePoseGraph_Request_DataWriter () {};
                ~DeserializePoseGraph_Request_DataWriter () {};
            private:
                DeserializePoseGraph_Request_DataWriter (const DeserializePoseGraph_Request_DataWriter &);
                DeserializePoseGraph_Request_DataWriter & operator = (const DeserializePoseGraph_Request_DataWriter &);
            };

            class  DeserializePoseGraph_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeserializePoseGraph_Request_DataReader_ptr _ptr_type;
                typedef DeserializePoseGraph_Request_DataReader_var _var_type;

                static DeserializePoseGraph_Request_DataReader_ptr _duplicate (DeserializePoseGraph_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeserializePoseGraph_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeserializePoseGraph_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeserializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeserializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeserializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeserializePoseGraph_Request_& instance) = 0;

            protected:
                DeserializePoseGraph_Request_DataReader () {};
                ~DeserializePoseGraph_Request_DataReader () {};
            private:
                DeserializePoseGraph_Request_DataReader (const DeserializePoseGraph_Request_DataReader &);
                DeserializePoseGraph_Request_DataReader & operator = (const DeserializePoseGraph_Request_DataReader &);
            };

            class  DeserializePoseGraph_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeserializePoseGraph_Request_DataReaderView_ptr _ptr_type;
                typedef DeserializePoseGraph_Request_DataReaderView_var _var_type;

                static DeserializePoseGraph_Request_DataReaderView_ptr _duplicate (DeserializePoseGraph_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeserializePoseGraph_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeserializePoseGraph_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeserializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeserializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeserializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeserializePoseGraph_Request_& instance) = 0;

            protected:
                DeserializePoseGraph_Request_DataReaderView () {};
                ~DeserializePoseGraph_Request_DataReaderView () {};
            private:
                DeserializePoseGraph_Request_DataReaderView (const DeserializePoseGraph_Request_DataReaderView &);
                DeserializePoseGraph_Request_DataReaderView & operator = (const DeserializePoseGraph_Request_DataReaderView &);
            };
            class DeserializePoseGraph_Response_TypeSupportInterface;

            typedef DeserializePoseGraph_Response_TypeSupportInterface * DeserializePoseGraph_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeserializePoseGraph_Response_TypeSupportInterface> DeserializePoseGraph_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeserializePoseGraph_Response_TypeSupportInterface> DeserializePoseGraph_Response_TypeSupportInterface_out;


            class DeserializePoseGraph_Response_DataWriter;

            typedef DeserializePoseGraph_Response_DataWriter * DeserializePoseGraph_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeserializePoseGraph_Response_DataWriter> DeserializePoseGraph_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeserializePoseGraph_Response_DataWriter> DeserializePoseGraph_Response_DataWriter_out;


            class DeserializePoseGraph_Response_DataReader;

            typedef DeserializePoseGraph_Response_DataReader * DeserializePoseGraph_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeserializePoseGraph_Response_DataReader> DeserializePoseGraph_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DeserializePoseGraph_Response_DataReader> DeserializePoseGraph_Response_DataReader_out;


            class DeserializePoseGraph_Response_DataReaderView;

            typedef DeserializePoseGraph_Response_DataReaderView * DeserializePoseGraph_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeserializePoseGraph_Response_DataReaderView> DeserializePoseGraph_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeserializePoseGraph_Response_DataReaderView> DeserializePoseGraph_Response_DataReaderView_out;

            struct DeserializePoseGraph_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DeserializePoseGraph_Response_, struct DeserializePoseGraph_Response_Seq_uniq_> DeserializePoseGraph_Response_Seq;
            typedef DDS_DCPSSequence_var < DeserializePoseGraph_Response_Seq> DeserializePoseGraph_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DeserializePoseGraph_Response_Seq> DeserializePoseGraph_Response_Seq_out;

            class  DeserializePoseGraph_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeserializePoseGraph_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DeserializePoseGraph_Response_TypeSupportInterface_var _var_type;

                static DeserializePoseGraph_Response_TypeSupportInterface_ptr _duplicate (DeserializePoseGraph_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeserializePoseGraph_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeserializePoseGraph_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeserializePoseGraph_Response_TypeSupportInterface () {};
                ~DeserializePoseGraph_Response_TypeSupportInterface () {};
            private:
                DeserializePoseGraph_Response_TypeSupportInterface (const DeserializePoseGraph_Response_TypeSupportInterface &);
                DeserializePoseGraph_Response_TypeSupportInterface & operator = (const DeserializePoseGraph_Response_TypeSupportInterface &);
            };

            class  DeserializePoseGraph_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeserializePoseGraph_Response_DataWriter_ptr _ptr_type;
                typedef DeserializePoseGraph_Response_DataWriter_var _var_type;

                static DeserializePoseGraph_Response_DataWriter_ptr _duplicate (DeserializePoseGraph_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeserializePoseGraph_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeserializePoseGraph_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeserializePoseGraph_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeserializePoseGraph_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeserializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeserializePoseGraph_Response_& instance_data) = 0;

            protected:
                DeserializePoseGraph_Response_DataWriter () {};
                ~DeserializePoseGraph_Response_DataWriter () {};
            private:
                DeserializePoseGraph_Response_DataWriter (const DeserializePoseGraph_Response_DataWriter &);
                DeserializePoseGraph_Response_DataWriter & operator = (const DeserializePoseGraph_Response_DataWriter &);
            };

            class  DeserializePoseGraph_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeserializePoseGraph_Response_DataReader_ptr _ptr_type;
                typedef DeserializePoseGraph_Response_DataReader_var _var_type;

                static DeserializePoseGraph_Response_DataReader_ptr _duplicate (DeserializePoseGraph_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeserializePoseGraph_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeserializePoseGraph_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeserializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeserializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeserializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeserializePoseGraph_Response_& instance) = 0;

            protected:
                DeserializePoseGraph_Response_DataReader () {};
                ~DeserializePoseGraph_Response_DataReader () {};
            private:
                DeserializePoseGraph_Response_DataReader (const DeserializePoseGraph_Response_DataReader &);
                DeserializePoseGraph_Response_DataReader & operator = (const DeserializePoseGraph_Response_DataReader &);
            };

            class  DeserializePoseGraph_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeserializePoseGraph_Response_DataReaderView_ptr _ptr_type;
                typedef DeserializePoseGraph_Response_DataReaderView_var _var_type;

                static DeserializePoseGraph_Response_DataReaderView_ptr _duplicate (DeserializePoseGraph_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeserializePoseGraph_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeserializePoseGraph_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeserializePoseGraph_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeserializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeserializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeserializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeserializePoseGraph_Response_& instance) = 0;

            protected:
                DeserializePoseGraph_Response_DataReaderView () {};
                ~DeserializePoseGraph_Response_DataReaderView () {};
            private:
                DeserializePoseGraph_Response_DataReaderView (const DeserializePoseGraph_Response_DataReaderView &);
                DeserializePoseGraph_Response_DataReaderView & operator = (const DeserializePoseGraph_Response_DataReaderView &);
            };
            class Sample_DeserializePoseGraph_Request_TypeSupportInterface;

            typedef Sample_DeserializePoseGraph_Request_TypeSupportInterface * Sample_DeserializePoseGraph_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeserializePoseGraph_Request_TypeSupportInterface> Sample_DeserializePoseGraph_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DeserializePoseGraph_Request_TypeSupportInterface> Sample_DeserializePoseGraph_Request_TypeSupportInterface_out;


            class Sample_DeserializePoseGraph_Request_DataWriter;

            typedef Sample_DeserializePoseGraph_Request_DataWriter * Sample_DeserializePoseGraph_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeserializePoseGraph_Request_DataWriter> Sample_DeserializePoseGraph_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DeserializePoseGraph_Request_DataWriter> Sample_DeserializePoseGraph_Request_DataWriter_out;


            class Sample_DeserializePoseGraph_Request_DataReader;

            typedef Sample_DeserializePoseGraph_Request_DataReader * Sample_DeserializePoseGraph_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeserializePoseGraph_Request_DataReader> Sample_DeserializePoseGraph_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DeserializePoseGraph_Request_DataReader> Sample_DeserializePoseGraph_Request_DataReader_out;


            class Sample_DeserializePoseGraph_Request_DataReaderView;

            typedef Sample_DeserializePoseGraph_Request_DataReaderView * Sample_DeserializePoseGraph_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeserializePoseGraph_Request_DataReaderView> Sample_DeserializePoseGraph_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DeserializePoseGraph_Request_DataReaderView> Sample_DeserializePoseGraph_Request_DataReaderView_out;

            struct Sample_DeserializePoseGraph_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DeserializePoseGraph_Request_, struct Sample_DeserializePoseGraph_Request_Seq_uniq_> Sample_DeserializePoseGraph_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_DeserializePoseGraph_Request_Seq> Sample_DeserializePoseGraph_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DeserializePoseGraph_Request_Seq> Sample_DeserializePoseGraph_Request_Seq_out;

            class  Sample_DeserializePoseGraph_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DeserializePoseGraph_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DeserializePoseGraph_Request_TypeSupportInterface_var _var_type;

                static Sample_DeserializePoseGraph_Request_TypeSupportInterface_ptr _duplicate (Sample_DeserializePoseGraph_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeserializePoseGraph_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeserializePoseGraph_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DeserializePoseGraph_Request_TypeSupportInterface () {};
                ~Sample_DeserializePoseGraph_Request_TypeSupportInterface () {};
            private:
                Sample_DeserializePoseGraph_Request_TypeSupportInterface (const Sample_DeserializePoseGraph_Request_TypeSupportInterface &);
                Sample_DeserializePoseGraph_Request_TypeSupportInterface & operator = (const Sample_DeserializePoseGraph_Request_TypeSupportInterface &);
            };

            class  Sample_DeserializePoseGraph_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DeserializePoseGraph_Request_DataWriter_ptr _ptr_type;
                typedef Sample_DeserializePoseGraph_Request_DataWriter_var _var_type;

                static Sample_DeserializePoseGraph_Request_DataWriter_ptr _duplicate (Sample_DeserializePoseGraph_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeserializePoseGraph_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeserializePoseGraph_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DeserializePoseGraph_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DeserializePoseGraph_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DeserializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DeserializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeserializePoseGraph_Request_& instance_data) = 0;

            protected:
                Sample_DeserializePoseGraph_Request_DataWriter () {};
                ~Sample_DeserializePoseGraph_Request_DataWriter () {};
            private:
                Sample_DeserializePoseGraph_Request_DataWriter (const Sample_DeserializePoseGraph_Request_DataWriter &);
                Sample_DeserializePoseGraph_Request_DataWriter & operator = (const Sample_DeserializePoseGraph_Request_DataWriter &);
            };

            class  Sample_DeserializePoseGraph_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DeserializePoseGraph_Request_DataReader_ptr _ptr_type;
                typedef Sample_DeserializePoseGraph_Request_DataReader_var _var_type;

                static Sample_DeserializePoseGraph_Request_DataReader_ptr _duplicate (Sample_DeserializePoseGraph_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeserializePoseGraph_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeserializePoseGraph_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeserializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeserializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeserializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeserializePoseGraph_Request_& instance) = 0;

            protected:
                Sample_DeserializePoseGraph_Request_DataReader () {};
                ~Sample_DeserializePoseGraph_Request_DataReader () {};
            private:
                Sample_DeserializePoseGraph_Request_DataReader (const Sample_DeserializePoseGraph_Request_DataReader &);
                Sample_DeserializePoseGraph_Request_DataReader & operator = (const Sample_DeserializePoseGraph_Request_DataReader &);
            };

            class  Sample_DeserializePoseGraph_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DeserializePoseGraph_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_DeserializePoseGraph_Request_DataReaderView_var _var_type;

                static Sample_DeserializePoseGraph_Request_DataReaderView_ptr _duplicate (Sample_DeserializePoseGraph_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeserializePoseGraph_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeserializePoseGraph_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeserializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeserializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeserializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeserializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeserializePoseGraph_Request_& instance) = 0;

            protected:
                Sample_DeserializePoseGraph_Request_DataReaderView () {};
                ~Sample_DeserializePoseGraph_Request_DataReaderView () {};
            private:
                Sample_DeserializePoseGraph_Request_DataReaderView (const Sample_DeserializePoseGraph_Request_DataReaderView &);
                Sample_DeserializePoseGraph_Request_DataReaderView & operator = (const Sample_DeserializePoseGraph_Request_DataReaderView &);
            };
            class Sample_DeserializePoseGraph_Response_TypeSupportInterface;

            typedef Sample_DeserializePoseGraph_Response_TypeSupportInterface * Sample_DeserializePoseGraph_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeserializePoseGraph_Response_TypeSupportInterface> Sample_DeserializePoseGraph_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DeserializePoseGraph_Response_TypeSupportInterface> Sample_DeserializePoseGraph_Response_TypeSupportInterface_out;


            class Sample_DeserializePoseGraph_Response_DataWriter;

            typedef Sample_DeserializePoseGraph_Response_DataWriter * Sample_DeserializePoseGraph_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeserializePoseGraph_Response_DataWriter> Sample_DeserializePoseGraph_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DeserializePoseGraph_Response_DataWriter> Sample_DeserializePoseGraph_Response_DataWriter_out;


            class Sample_DeserializePoseGraph_Response_DataReader;

            typedef Sample_DeserializePoseGraph_Response_DataReader * Sample_DeserializePoseGraph_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeserializePoseGraph_Response_DataReader> Sample_DeserializePoseGraph_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DeserializePoseGraph_Response_DataReader> Sample_DeserializePoseGraph_Response_DataReader_out;


            class Sample_DeserializePoseGraph_Response_DataReaderView;

            typedef Sample_DeserializePoseGraph_Response_DataReaderView * Sample_DeserializePoseGraph_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeserializePoseGraph_Response_DataReaderView> Sample_DeserializePoseGraph_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DeserializePoseGraph_Response_DataReaderView> Sample_DeserializePoseGraph_Response_DataReaderView_out;

            struct Sample_DeserializePoseGraph_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_DeserializePoseGraph_Response_, struct Sample_DeserializePoseGraph_Response_Seq_uniq_> Sample_DeserializePoseGraph_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_DeserializePoseGraph_Response_Seq> Sample_DeserializePoseGraph_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DeserializePoseGraph_Response_Seq> Sample_DeserializePoseGraph_Response_Seq_out;

            class  Sample_DeserializePoseGraph_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DeserializePoseGraph_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DeserializePoseGraph_Response_TypeSupportInterface_var _var_type;

                static Sample_DeserializePoseGraph_Response_TypeSupportInterface_ptr _duplicate (Sample_DeserializePoseGraph_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeserializePoseGraph_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeserializePoseGraph_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DeserializePoseGraph_Response_TypeSupportInterface () {};
                ~Sample_DeserializePoseGraph_Response_TypeSupportInterface () {};
            private:
                Sample_DeserializePoseGraph_Response_TypeSupportInterface (const Sample_DeserializePoseGraph_Response_TypeSupportInterface &);
                Sample_DeserializePoseGraph_Response_TypeSupportInterface & operator = (const Sample_DeserializePoseGraph_Response_TypeSupportInterface &);
            };

            class  Sample_DeserializePoseGraph_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DeserializePoseGraph_Response_DataWriter_ptr _ptr_type;
                typedef Sample_DeserializePoseGraph_Response_DataWriter_var _var_type;

                static Sample_DeserializePoseGraph_Response_DataWriter_ptr _duplicate (Sample_DeserializePoseGraph_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeserializePoseGraph_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeserializePoseGraph_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DeserializePoseGraph_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DeserializePoseGraph_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DeserializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DeserializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeserializePoseGraph_Response_& instance_data) = 0;

            protected:
                Sample_DeserializePoseGraph_Response_DataWriter () {};
                ~Sample_DeserializePoseGraph_Response_DataWriter () {};
            private:
                Sample_DeserializePoseGraph_Response_DataWriter (const Sample_DeserializePoseGraph_Response_DataWriter &);
                Sample_DeserializePoseGraph_Response_DataWriter & operator = (const Sample_DeserializePoseGraph_Response_DataWriter &);
            };

            class  Sample_DeserializePoseGraph_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DeserializePoseGraph_Response_DataReader_ptr _ptr_type;
                typedef Sample_DeserializePoseGraph_Response_DataReader_var _var_type;

                static Sample_DeserializePoseGraph_Response_DataReader_ptr _duplicate (Sample_DeserializePoseGraph_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeserializePoseGraph_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeserializePoseGraph_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeserializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeserializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeserializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeserializePoseGraph_Response_& instance) = 0;

            protected:
                Sample_DeserializePoseGraph_Response_DataReader () {};
                ~Sample_DeserializePoseGraph_Response_DataReader () {};
            private:
                Sample_DeserializePoseGraph_Response_DataReader (const Sample_DeserializePoseGraph_Response_DataReader &);
                Sample_DeserializePoseGraph_Response_DataReader & operator = (const Sample_DeserializePoseGraph_Response_DataReader &);
            };

            class  Sample_DeserializePoseGraph_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DeserializePoseGraph_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_DeserializePoseGraph_Response_DataReaderView_var _var_type;

                static Sample_DeserializePoseGraph_Response_DataReaderView_ptr _duplicate (Sample_DeserializePoseGraph_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeserializePoseGraph_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeserializePoseGraph_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeserializePoseGraph_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeserializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeserializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeserializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeserializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeserializePoseGraph_Response_& instance) = 0;

            protected:
                Sample_DeserializePoseGraph_Response_DataReaderView () {};
                ~Sample_DeserializePoseGraph_Response_DataReaderView () {};
            private:
                Sample_DeserializePoseGraph_Response_DataReaderView (const Sample_DeserializePoseGraph_Response_DataReaderView &);
                Sample_DeserializePoseGraph_Response_DataReaderView & operator = (const Sample_DeserializePoseGraph_Response_DataReaderView &);
            };
        }

    }

}

#endif
