#ifndef _H_791FCD6BEE541AF023BD09B581BAD960_LoopClosure__H_
#define _H_791FCD6BEE541AF023BD09B581BAD960_LoopClosure__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            struct  LoopClosure_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<LoopClosure_Request_> LoopClosure_Request__var;
            typedef LoopClosure_Request_& LoopClosure_Request__out;

            struct  LoopClosure_Response_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<LoopClosure_Response_> LoopClosure_Response__var;
            typedef LoopClosure_Response_& LoopClosure_Response__out;

            struct  Sample_LoopClosure_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::LoopClosure_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_LoopClosure_Request_> Sample_LoopClosure_Request__var;
            typedef Sample_LoopClosure_Request_& Sample_LoopClosure_Request__out;

            struct  Sample_LoopClosure_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::LoopClosure_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_LoopClosure_Response_> Sample_LoopClosure_Response__var;
            typedef Sample_LoopClosure_Response_& Sample_LoopClosure_Response__out;

        }

    }

}

#endif /* _H_791FCD6BEE541AF023BD09B581BAD960_LoopClosure__H_ */
