#ifndef _H_791FCD6BEE541AF023BD09B581BAD960_LoopClosure_DCPS_H_
#define _H_791FCD6BEE541AF023BD09B581BAD960_LoopClosure_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LoopClosure_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            class LoopClosure_Request_TypeSupportInterface;

            typedef LoopClosure_Request_TypeSupportInterface * LoopClosure_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LoopClosure_Request_TypeSupportInterface> LoopClosure_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LoopClosure_Request_TypeSupportInterface> LoopClosure_Request_TypeSupportInterface_out;


            class LoopClosure_Request_DataWriter;

            typedef LoopClosure_Request_DataWriter * LoopClosure_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LoopClosure_Request_DataWriter> LoopClosure_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < LoopClosure_Request_DataWriter> LoopClosure_Request_DataWriter_out;


            class LoopClosure_Request_DataReader;

            typedef LoopClosure_Request_DataReader * LoopClosure_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LoopClosure_Request_DataReader> LoopClosure_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < LoopClosure_Request_DataReader> LoopClosure_Request_DataReader_out;


            class LoopClosure_Request_DataReaderView;

            typedef LoopClosure_Request_DataReaderView * LoopClosure_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LoopClosure_Request_DataReaderView> LoopClosure_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LoopClosure_Request_DataReaderView> LoopClosure_Request_DataReaderView_out;

            struct LoopClosure_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < LoopClosure_Request_, struct LoopClosure_Request_Seq_uniq_> LoopClosure_Request_Seq;
            typedef DDS_DCPSSequence_var < LoopClosure_Request_Seq> LoopClosure_Request_Seq_var;
            typedef DDS_DCPSSequence_out < LoopClosure_Request_Seq> LoopClosure_Request_Seq_out;

            class  LoopClosure_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LoopClosure_Request_TypeSupportInterface_ptr _ptr_type;
                typedef LoopClosure_Request_TypeSupportInterface_var _var_type;

                static LoopClosure_Request_TypeSupportInterface_ptr _duplicate (LoopClosure_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoopClosure_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LoopClosure_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoopClosure_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LoopClosure_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LoopClosure_Request_TypeSupportInterface () {};
                ~LoopClosure_Request_TypeSupportInterface () {};
            private:
                LoopClosure_Request_TypeSupportInterface (const LoopClosure_Request_TypeSupportInterface &);
                LoopClosure_Request_TypeSupportInterface & operator = (const LoopClosure_Request_TypeSupportInterface &);
            };

            class  LoopClosure_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LoopClosure_Request_DataWriter_ptr _ptr_type;
                typedef LoopClosure_Request_DataWriter_var _var_type;

                static LoopClosure_Request_DataWriter_ptr _duplicate (LoopClosure_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoopClosure_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LoopClosure_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoopClosure_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LoopClosure_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LoopClosure_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LoopClosure_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LoopClosure_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LoopClosure_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LoopClosure_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LoopClosure_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LoopClosure_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LoopClosure_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LoopClosure_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LoopClosure_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LoopClosure_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoopClosure_Request_& instance_data) = 0;

            protected:
                LoopClosure_Request_DataWriter () {};
                ~LoopClosure_Request_DataWriter () {};
            private:
                LoopClosure_Request_DataWriter (const LoopClosure_Request_DataWriter &);
                LoopClosure_Request_DataWriter & operator = (const LoopClosure_Request_DataWriter &);
            };

            class  LoopClosure_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LoopClosure_Request_DataReader_ptr _ptr_type;
                typedef LoopClosure_Request_DataReader_var _var_type;

                static LoopClosure_Request_DataReader_ptr _duplicate (LoopClosure_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoopClosure_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LoopClosure_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoopClosure_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LoopClosure_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoopClosure_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoopClosure_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoopClosure_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoopClosure_Request_& instance) = 0;

            protected:
                LoopClosure_Request_DataReader () {};
                ~LoopClosure_Request_DataReader () {};
            private:
                LoopClosure_Request_DataReader (const LoopClosure_Request_DataReader &);
                LoopClosure_Request_DataReader & operator = (const LoopClosure_Request_DataReader &);
            };

            class  LoopClosure_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LoopClosure_Request_DataReaderView_ptr _ptr_type;
                typedef LoopClosure_Request_DataReaderView_var _var_type;

                static LoopClosure_Request_DataReaderView_ptr _duplicate (LoopClosure_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoopClosure_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LoopClosure_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoopClosure_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LoopClosure_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoopClosure_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoopClosure_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoopClosure_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoopClosure_Request_& instance) = 0;

            protected:
                LoopClosure_Request_DataReaderView () {};
                ~LoopClosure_Request_DataReaderView () {};
            private:
                LoopClosure_Request_DataReaderView (const LoopClosure_Request_DataReaderView &);
                LoopClosure_Request_DataReaderView & operator = (const LoopClosure_Request_DataReaderView &);
            };
            class LoopClosure_Response_TypeSupportInterface;

            typedef LoopClosure_Response_TypeSupportInterface * LoopClosure_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LoopClosure_Response_TypeSupportInterface> LoopClosure_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LoopClosure_Response_TypeSupportInterface> LoopClosure_Response_TypeSupportInterface_out;


            class LoopClosure_Response_DataWriter;

            typedef LoopClosure_Response_DataWriter * LoopClosure_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LoopClosure_Response_DataWriter> LoopClosure_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < LoopClosure_Response_DataWriter> LoopClosure_Response_DataWriter_out;


            class LoopClosure_Response_DataReader;

            typedef LoopClosure_Response_DataReader * LoopClosure_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LoopClosure_Response_DataReader> LoopClosure_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < LoopClosure_Response_DataReader> LoopClosure_Response_DataReader_out;


            class LoopClosure_Response_DataReaderView;

            typedef LoopClosure_Response_DataReaderView * LoopClosure_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LoopClosure_Response_DataReaderView> LoopClosure_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LoopClosure_Response_DataReaderView> LoopClosure_Response_DataReaderView_out;

            struct LoopClosure_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < LoopClosure_Response_, struct LoopClosure_Response_Seq_uniq_> LoopClosure_Response_Seq;
            typedef DDS_DCPSSequence_var < LoopClosure_Response_Seq> LoopClosure_Response_Seq_var;
            typedef DDS_DCPSSequence_out < LoopClosure_Response_Seq> LoopClosure_Response_Seq_out;

            class  LoopClosure_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LoopClosure_Response_TypeSupportInterface_ptr _ptr_type;
                typedef LoopClosure_Response_TypeSupportInterface_var _var_type;

                static LoopClosure_Response_TypeSupportInterface_ptr _duplicate (LoopClosure_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoopClosure_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LoopClosure_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoopClosure_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LoopClosure_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LoopClosure_Response_TypeSupportInterface () {};
                ~LoopClosure_Response_TypeSupportInterface () {};
            private:
                LoopClosure_Response_TypeSupportInterface (const LoopClosure_Response_TypeSupportInterface &);
                LoopClosure_Response_TypeSupportInterface & operator = (const LoopClosure_Response_TypeSupportInterface &);
            };

            class  LoopClosure_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LoopClosure_Response_DataWriter_ptr _ptr_type;
                typedef LoopClosure_Response_DataWriter_var _var_type;

                static LoopClosure_Response_DataWriter_ptr _duplicate (LoopClosure_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoopClosure_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LoopClosure_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoopClosure_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LoopClosure_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LoopClosure_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LoopClosure_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LoopClosure_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LoopClosure_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LoopClosure_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LoopClosure_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LoopClosure_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LoopClosure_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LoopClosure_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LoopClosure_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LoopClosure_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoopClosure_Response_& instance_data) = 0;

            protected:
                LoopClosure_Response_DataWriter () {};
                ~LoopClosure_Response_DataWriter () {};
            private:
                LoopClosure_Response_DataWriter (const LoopClosure_Response_DataWriter &);
                LoopClosure_Response_DataWriter & operator = (const LoopClosure_Response_DataWriter &);
            };

            class  LoopClosure_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LoopClosure_Response_DataReader_ptr _ptr_type;
                typedef LoopClosure_Response_DataReader_var _var_type;

                static LoopClosure_Response_DataReader_ptr _duplicate (LoopClosure_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoopClosure_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LoopClosure_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoopClosure_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LoopClosure_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoopClosure_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoopClosure_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoopClosure_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoopClosure_Response_& instance) = 0;

            protected:
                LoopClosure_Response_DataReader () {};
                ~LoopClosure_Response_DataReader () {};
            private:
                LoopClosure_Response_DataReader (const LoopClosure_Response_DataReader &);
                LoopClosure_Response_DataReader & operator = (const LoopClosure_Response_DataReader &);
            };

            class  LoopClosure_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LoopClosure_Response_DataReaderView_ptr _ptr_type;
                typedef LoopClosure_Response_DataReaderView_var _var_type;

                static LoopClosure_Response_DataReaderView_ptr _duplicate (LoopClosure_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoopClosure_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LoopClosure_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoopClosure_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LoopClosure_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoopClosure_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoopClosure_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoopClosure_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoopClosure_Response_& instance) = 0;

            protected:
                LoopClosure_Response_DataReaderView () {};
                ~LoopClosure_Response_DataReaderView () {};
            private:
                LoopClosure_Response_DataReaderView (const LoopClosure_Response_DataReaderView &);
                LoopClosure_Response_DataReaderView & operator = (const LoopClosure_Response_DataReaderView &);
            };
            class Sample_LoopClosure_Request_TypeSupportInterface;

            typedef Sample_LoopClosure_Request_TypeSupportInterface * Sample_LoopClosure_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_LoopClosure_Request_TypeSupportInterface> Sample_LoopClosure_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_LoopClosure_Request_TypeSupportInterface> Sample_LoopClosure_Request_TypeSupportInterface_out;


            class Sample_LoopClosure_Request_DataWriter;

            typedef Sample_LoopClosure_Request_DataWriter * Sample_LoopClosure_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_LoopClosure_Request_DataWriter> Sample_LoopClosure_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_LoopClosure_Request_DataWriter> Sample_LoopClosure_Request_DataWriter_out;


            class Sample_LoopClosure_Request_DataReader;

            typedef Sample_LoopClosure_Request_DataReader * Sample_LoopClosure_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_LoopClosure_Request_DataReader> Sample_LoopClosure_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_LoopClosure_Request_DataReader> Sample_LoopClosure_Request_DataReader_out;


            class Sample_LoopClosure_Request_DataReaderView;

            typedef Sample_LoopClosure_Request_DataReaderView * Sample_LoopClosure_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_LoopClosure_Request_DataReaderView> Sample_LoopClosure_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_LoopClosure_Request_DataReaderView> Sample_LoopClosure_Request_DataReaderView_out;

            struct Sample_LoopClosure_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_LoopClosure_Request_, struct Sample_LoopClosure_Request_Seq_uniq_> Sample_LoopClosure_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_LoopClosure_Request_Seq> Sample_LoopClosure_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_LoopClosure_Request_Seq> Sample_LoopClosure_Request_Seq_out;

            class  Sample_LoopClosure_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_LoopClosure_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_LoopClosure_Request_TypeSupportInterface_var _var_type;

                static Sample_LoopClosure_Request_TypeSupportInterface_ptr _duplicate (Sample_LoopClosure_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_LoopClosure_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_LoopClosure_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_LoopClosure_Request_TypeSupportInterface () {};
                ~Sample_LoopClosure_Request_TypeSupportInterface () {};
            private:
                Sample_LoopClosure_Request_TypeSupportInterface (const Sample_LoopClosure_Request_TypeSupportInterface &);
                Sample_LoopClosure_Request_TypeSupportInterface & operator = (const Sample_LoopClosure_Request_TypeSupportInterface &);
            };

            class  Sample_LoopClosure_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_LoopClosure_Request_DataWriter_ptr _ptr_type;
                typedef Sample_LoopClosure_Request_DataWriter_var _var_type;

                static Sample_LoopClosure_Request_DataWriter_ptr _duplicate (Sample_LoopClosure_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_LoopClosure_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_LoopClosure_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_LoopClosure_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_LoopClosure_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_LoopClosure_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_LoopClosure_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_LoopClosure_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_LoopClosure_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_LoopClosure_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_LoopClosure_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_LoopClosure_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_LoopClosure_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_LoopClosure_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_LoopClosure_Request_& instance_data) = 0;

            protected:
                Sample_LoopClosure_Request_DataWriter () {};
                ~Sample_LoopClosure_Request_DataWriter () {};
            private:
                Sample_LoopClosure_Request_DataWriter (const Sample_LoopClosure_Request_DataWriter &);
                Sample_LoopClosure_Request_DataWriter & operator = (const Sample_LoopClosure_Request_DataWriter &);
            };

            class  Sample_LoopClosure_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_LoopClosure_Request_DataReader_ptr _ptr_type;
                typedef Sample_LoopClosure_Request_DataReader_var _var_type;

                static Sample_LoopClosure_Request_DataReader_ptr _duplicate (Sample_LoopClosure_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_LoopClosure_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_LoopClosure_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_LoopClosure_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_LoopClosure_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_LoopClosure_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_LoopClosure_Request_& instance) = 0;

            protected:
                Sample_LoopClosure_Request_DataReader () {};
                ~Sample_LoopClosure_Request_DataReader () {};
            private:
                Sample_LoopClosure_Request_DataReader (const Sample_LoopClosure_Request_DataReader &);
                Sample_LoopClosure_Request_DataReader & operator = (const Sample_LoopClosure_Request_DataReader &);
            };

            class  Sample_LoopClosure_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_LoopClosure_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_LoopClosure_Request_DataReaderView_var _var_type;

                static Sample_LoopClosure_Request_DataReaderView_ptr _duplicate (Sample_LoopClosure_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_LoopClosure_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_LoopClosure_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_LoopClosure_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_LoopClosure_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_LoopClosure_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_LoopClosure_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_LoopClosure_Request_& instance) = 0;

            protected:
                Sample_LoopClosure_Request_DataReaderView () {};
                ~Sample_LoopClosure_Request_DataReaderView () {};
            private:
                Sample_LoopClosure_Request_DataReaderView (const Sample_LoopClosure_Request_DataReaderView &);
                Sample_LoopClosure_Request_DataReaderView & operator = (const Sample_LoopClosure_Request_DataReaderView &);
            };
            class Sample_LoopClosure_Response_TypeSupportInterface;

            typedef Sample_LoopClosure_Response_TypeSupportInterface * Sample_LoopClosure_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_LoopClosure_Response_TypeSupportInterface> Sample_LoopClosure_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_LoopClosure_Response_TypeSupportInterface> Sample_LoopClosure_Response_TypeSupportInterface_out;


            class Sample_LoopClosure_Response_DataWriter;

            typedef Sample_LoopClosure_Response_DataWriter * Sample_LoopClosure_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_LoopClosure_Response_DataWriter> Sample_LoopClosure_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_LoopClosure_Response_DataWriter> Sample_LoopClosure_Response_DataWriter_out;


            class Sample_LoopClosure_Response_DataReader;

            typedef Sample_LoopClosure_Response_DataReader * Sample_LoopClosure_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_LoopClosure_Response_DataReader> Sample_LoopClosure_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_LoopClosure_Response_DataReader> Sample_LoopClosure_Response_DataReader_out;


            class Sample_LoopClosure_Response_DataReaderView;

            typedef Sample_LoopClosure_Response_DataReaderView * Sample_LoopClosure_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_LoopClosure_Response_DataReaderView> Sample_LoopClosure_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_LoopClosure_Response_DataReaderView> Sample_LoopClosure_Response_DataReaderView_out;

            struct Sample_LoopClosure_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_LoopClosure_Response_, struct Sample_LoopClosure_Response_Seq_uniq_> Sample_LoopClosure_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_LoopClosure_Response_Seq> Sample_LoopClosure_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_LoopClosure_Response_Seq> Sample_LoopClosure_Response_Seq_out;

            class  Sample_LoopClosure_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_LoopClosure_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_LoopClosure_Response_TypeSupportInterface_var _var_type;

                static Sample_LoopClosure_Response_TypeSupportInterface_ptr _duplicate (Sample_LoopClosure_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_LoopClosure_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_LoopClosure_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_LoopClosure_Response_TypeSupportInterface () {};
                ~Sample_LoopClosure_Response_TypeSupportInterface () {};
            private:
                Sample_LoopClosure_Response_TypeSupportInterface (const Sample_LoopClosure_Response_TypeSupportInterface &);
                Sample_LoopClosure_Response_TypeSupportInterface & operator = (const Sample_LoopClosure_Response_TypeSupportInterface &);
            };

            class  Sample_LoopClosure_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_LoopClosure_Response_DataWriter_ptr _ptr_type;
                typedef Sample_LoopClosure_Response_DataWriter_var _var_type;

                static Sample_LoopClosure_Response_DataWriter_ptr _duplicate (Sample_LoopClosure_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_LoopClosure_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_LoopClosure_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_LoopClosure_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_LoopClosure_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_LoopClosure_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_LoopClosure_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_LoopClosure_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_LoopClosure_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_LoopClosure_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_LoopClosure_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_LoopClosure_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_LoopClosure_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_LoopClosure_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_LoopClosure_Response_& instance_data) = 0;

            protected:
                Sample_LoopClosure_Response_DataWriter () {};
                ~Sample_LoopClosure_Response_DataWriter () {};
            private:
                Sample_LoopClosure_Response_DataWriter (const Sample_LoopClosure_Response_DataWriter &);
                Sample_LoopClosure_Response_DataWriter & operator = (const Sample_LoopClosure_Response_DataWriter &);
            };

            class  Sample_LoopClosure_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_LoopClosure_Response_DataReader_ptr _ptr_type;
                typedef Sample_LoopClosure_Response_DataReader_var _var_type;

                static Sample_LoopClosure_Response_DataReader_ptr _duplicate (Sample_LoopClosure_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_LoopClosure_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_LoopClosure_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_LoopClosure_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_LoopClosure_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_LoopClosure_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_LoopClosure_Response_& instance) = 0;

            protected:
                Sample_LoopClosure_Response_DataReader () {};
                ~Sample_LoopClosure_Response_DataReader () {};
            private:
                Sample_LoopClosure_Response_DataReader (const Sample_LoopClosure_Response_DataReader &);
                Sample_LoopClosure_Response_DataReader & operator = (const Sample_LoopClosure_Response_DataReader &);
            };

            class  Sample_LoopClosure_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_LoopClosure_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_LoopClosure_Response_DataReaderView_var _var_type;

                static Sample_LoopClosure_Response_DataReaderView_ptr _duplicate (Sample_LoopClosure_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_LoopClosure_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_LoopClosure_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_LoopClosure_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_LoopClosure_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_LoopClosure_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_LoopClosure_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_LoopClosure_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_LoopClosure_Response_& instance) = 0;

            protected:
                Sample_LoopClosure_Response_DataReaderView () {};
                ~Sample_LoopClosure_Response_DataReaderView () {};
            private:
                Sample_LoopClosure_Response_DataReaderView (const Sample_LoopClosure_Response_DataReaderView &);
                Sample_LoopClosure_Response_DataReaderView & operator = (const Sample_LoopClosure_Response_DataReaderView &);
            };
        }

    }

}

#endif
