#ifndef _H_F95EC80BF10669BD15C6AE9F0443B8BD_SerializePoseGraph_DCPS_H_
#define _H_F95EC80BF10669BD15C6AE9F0443B8BD_SerializePoseGraph_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SerializePoseGraph_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            class SerializePoseGraph_Request_TypeSupportInterface;

            typedef SerializePoseGraph_Request_TypeSupportInterface * SerializePoseGraph_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SerializePoseGraph_Request_TypeSupportInterface> SerializePoseGraph_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SerializePoseGraph_Request_TypeSupportInterface> SerializePoseGraph_Request_TypeSupportInterface_out;


            class SerializePoseGraph_Request_DataWriter;

            typedef SerializePoseGraph_Request_DataWriter * SerializePoseGraph_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SerializePoseGraph_Request_DataWriter> SerializePoseGraph_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SerializePoseGraph_Request_DataWriter> SerializePoseGraph_Request_DataWriter_out;


            class SerializePoseGraph_Request_DataReader;

            typedef SerializePoseGraph_Request_DataReader * SerializePoseGraph_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SerializePoseGraph_Request_DataReader> SerializePoseGraph_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SerializePoseGraph_Request_DataReader> SerializePoseGraph_Request_DataReader_out;


            class SerializePoseGraph_Request_DataReaderView;

            typedef SerializePoseGraph_Request_DataReaderView * SerializePoseGraph_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SerializePoseGraph_Request_DataReaderView> SerializePoseGraph_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SerializePoseGraph_Request_DataReaderView> SerializePoseGraph_Request_DataReaderView_out;

            struct SerializePoseGraph_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SerializePoseGraph_Request_, struct SerializePoseGraph_Request_Seq_uniq_> SerializePoseGraph_Request_Seq;
            typedef DDS_DCPSSequence_var < SerializePoseGraph_Request_Seq> SerializePoseGraph_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SerializePoseGraph_Request_Seq> SerializePoseGraph_Request_Seq_out;

            class  SerializePoseGraph_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SerializePoseGraph_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SerializePoseGraph_Request_TypeSupportInterface_var _var_type;

                static SerializePoseGraph_Request_TypeSupportInterface_ptr _duplicate (SerializePoseGraph_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SerializePoseGraph_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SerializePoseGraph_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SerializePoseGraph_Request_TypeSupportInterface () {};
                ~SerializePoseGraph_Request_TypeSupportInterface () {};
            private:
                SerializePoseGraph_Request_TypeSupportInterface (const SerializePoseGraph_Request_TypeSupportInterface &);
                SerializePoseGraph_Request_TypeSupportInterface & operator = (const SerializePoseGraph_Request_TypeSupportInterface &);
            };

            class  SerializePoseGraph_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SerializePoseGraph_Request_DataWriter_ptr _ptr_type;
                typedef SerializePoseGraph_Request_DataWriter_var _var_type;

                static SerializePoseGraph_Request_DataWriter_ptr _duplicate (SerializePoseGraph_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SerializePoseGraph_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SerializePoseGraph_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SerializePoseGraph_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SerializePoseGraph_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SerializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SerializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SerializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SerializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SerializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SerializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SerializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SerializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SerializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SerializePoseGraph_Request_& instance_data) = 0;

            protected:
                SerializePoseGraph_Request_DataWriter () {};
                ~SerializePoseGraph_Request_DataWriter () {};
            private:
                SerializePoseGraph_Request_DataWriter (const SerializePoseGraph_Request_DataWriter &);
                SerializePoseGraph_Request_DataWriter & operator = (const SerializePoseGraph_Request_DataWriter &);
            };

            class  SerializePoseGraph_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SerializePoseGraph_Request_DataReader_ptr _ptr_type;
                typedef SerializePoseGraph_Request_DataReader_var _var_type;

                static SerializePoseGraph_Request_DataReader_ptr _duplicate (SerializePoseGraph_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SerializePoseGraph_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SerializePoseGraph_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SerializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SerializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SerializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SerializePoseGraph_Request_& instance) = 0;

            protected:
                SerializePoseGraph_Request_DataReader () {};
                ~SerializePoseGraph_Request_DataReader () {};
            private:
                SerializePoseGraph_Request_DataReader (const SerializePoseGraph_Request_DataReader &);
                SerializePoseGraph_Request_DataReader & operator = (const SerializePoseGraph_Request_DataReader &);
            };

            class  SerializePoseGraph_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SerializePoseGraph_Request_DataReaderView_ptr _ptr_type;
                typedef SerializePoseGraph_Request_DataReaderView_var _var_type;

                static SerializePoseGraph_Request_DataReaderView_ptr _duplicate (SerializePoseGraph_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SerializePoseGraph_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SerializePoseGraph_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SerializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SerializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SerializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SerializePoseGraph_Request_& instance) = 0;

            protected:
                SerializePoseGraph_Request_DataReaderView () {};
                ~SerializePoseGraph_Request_DataReaderView () {};
            private:
                SerializePoseGraph_Request_DataReaderView (const SerializePoseGraph_Request_DataReaderView &);
                SerializePoseGraph_Request_DataReaderView & operator = (const SerializePoseGraph_Request_DataReaderView &);
            };
            class SerializePoseGraph_Response_TypeSupportInterface;

            typedef SerializePoseGraph_Response_TypeSupportInterface * SerializePoseGraph_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SerializePoseGraph_Response_TypeSupportInterface> SerializePoseGraph_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SerializePoseGraph_Response_TypeSupportInterface> SerializePoseGraph_Response_TypeSupportInterface_out;


            class SerializePoseGraph_Response_DataWriter;

            typedef SerializePoseGraph_Response_DataWriter * SerializePoseGraph_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SerializePoseGraph_Response_DataWriter> SerializePoseGraph_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SerializePoseGraph_Response_DataWriter> SerializePoseGraph_Response_DataWriter_out;


            class SerializePoseGraph_Response_DataReader;

            typedef SerializePoseGraph_Response_DataReader * SerializePoseGraph_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SerializePoseGraph_Response_DataReader> SerializePoseGraph_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SerializePoseGraph_Response_DataReader> SerializePoseGraph_Response_DataReader_out;


            class SerializePoseGraph_Response_DataReaderView;

            typedef SerializePoseGraph_Response_DataReaderView * SerializePoseGraph_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SerializePoseGraph_Response_DataReaderView> SerializePoseGraph_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SerializePoseGraph_Response_DataReaderView> SerializePoseGraph_Response_DataReaderView_out;

            struct SerializePoseGraph_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SerializePoseGraph_Response_, struct SerializePoseGraph_Response_Seq_uniq_> SerializePoseGraph_Response_Seq;
            typedef DDS_DCPSSequence_var < SerializePoseGraph_Response_Seq> SerializePoseGraph_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SerializePoseGraph_Response_Seq> SerializePoseGraph_Response_Seq_out;

            class  SerializePoseGraph_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SerializePoseGraph_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SerializePoseGraph_Response_TypeSupportInterface_var _var_type;

                static SerializePoseGraph_Response_TypeSupportInterface_ptr _duplicate (SerializePoseGraph_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SerializePoseGraph_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SerializePoseGraph_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SerializePoseGraph_Response_TypeSupportInterface () {};
                ~SerializePoseGraph_Response_TypeSupportInterface () {};
            private:
                SerializePoseGraph_Response_TypeSupportInterface (const SerializePoseGraph_Response_TypeSupportInterface &);
                SerializePoseGraph_Response_TypeSupportInterface & operator = (const SerializePoseGraph_Response_TypeSupportInterface &);
            };

            class  SerializePoseGraph_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SerializePoseGraph_Response_DataWriter_ptr _ptr_type;
                typedef SerializePoseGraph_Response_DataWriter_var _var_type;

                static SerializePoseGraph_Response_DataWriter_ptr _duplicate (SerializePoseGraph_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SerializePoseGraph_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SerializePoseGraph_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SerializePoseGraph_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SerializePoseGraph_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SerializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SerializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SerializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SerializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SerializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SerializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SerializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SerializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SerializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SerializePoseGraph_Response_& instance_data) = 0;

            protected:
                SerializePoseGraph_Response_DataWriter () {};
                ~SerializePoseGraph_Response_DataWriter () {};
            private:
                SerializePoseGraph_Response_DataWriter (const SerializePoseGraph_Response_DataWriter &);
                SerializePoseGraph_Response_DataWriter & operator = (const SerializePoseGraph_Response_DataWriter &);
            };

            class  SerializePoseGraph_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SerializePoseGraph_Response_DataReader_ptr _ptr_type;
                typedef SerializePoseGraph_Response_DataReader_var _var_type;

                static SerializePoseGraph_Response_DataReader_ptr _duplicate (SerializePoseGraph_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SerializePoseGraph_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SerializePoseGraph_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SerializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SerializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SerializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SerializePoseGraph_Response_& instance) = 0;

            protected:
                SerializePoseGraph_Response_DataReader () {};
                ~SerializePoseGraph_Response_DataReader () {};
            private:
                SerializePoseGraph_Response_DataReader (const SerializePoseGraph_Response_DataReader &);
                SerializePoseGraph_Response_DataReader & operator = (const SerializePoseGraph_Response_DataReader &);
            };

            class  SerializePoseGraph_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SerializePoseGraph_Response_DataReaderView_ptr _ptr_type;
                typedef SerializePoseGraph_Response_DataReaderView_var _var_type;

                static SerializePoseGraph_Response_DataReaderView_ptr _duplicate (SerializePoseGraph_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SerializePoseGraph_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SerializePoseGraph_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SerializePoseGraph_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SerializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SerializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SerializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SerializePoseGraph_Response_& instance) = 0;

            protected:
                SerializePoseGraph_Response_DataReaderView () {};
                ~SerializePoseGraph_Response_DataReaderView () {};
            private:
                SerializePoseGraph_Response_DataReaderView (const SerializePoseGraph_Response_DataReaderView &);
                SerializePoseGraph_Response_DataReaderView & operator = (const SerializePoseGraph_Response_DataReaderView &);
            };
            class Sample_SerializePoseGraph_Request_TypeSupportInterface;

            typedef Sample_SerializePoseGraph_Request_TypeSupportInterface * Sample_SerializePoseGraph_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SerializePoseGraph_Request_TypeSupportInterface> Sample_SerializePoseGraph_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SerializePoseGraph_Request_TypeSupportInterface> Sample_SerializePoseGraph_Request_TypeSupportInterface_out;


            class Sample_SerializePoseGraph_Request_DataWriter;

            typedef Sample_SerializePoseGraph_Request_DataWriter * Sample_SerializePoseGraph_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SerializePoseGraph_Request_DataWriter> Sample_SerializePoseGraph_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SerializePoseGraph_Request_DataWriter> Sample_SerializePoseGraph_Request_DataWriter_out;


            class Sample_SerializePoseGraph_Request_DataReader;

            typedef Sample_SerializePoseGraph_Request_DataReader * Sample_SerializePoseGraph_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SerializePoseGraph_Request_DataReader> Sample_SerializePoseGraph_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SerializePoseGraph_Request_DataReader> Sample_SerializePoseGraph_Request_DataReader_out;


            class Sample_SerializePoseGraph_Request_DataReaderView;

            typedef Sample_SerializePoseGraph_Request_DataReaderView * Sample_SerializePoseGraph_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SerializePoseGraph_Request_DataReaderView> Sample_SerializePoseGraph_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SerializePoseGraph_Request_DataReaderView> Sample_SerializePoseGraph_Request_DataReaderView_out;

            struct Sample_SerializePoseGraph_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SerializePoseGraph_Request_, struct Sample_SerializePoseGraph_Request_Seq_uniq_> Sample_SerializePoseGraph_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SerializePoseGraph_Request_Seq> Sample_SerializePoseGraph_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SerializePoseGraph_Request_Seq> Sample_SerializePoseGraph_Request_Seq_out;

            class  Sample_SerializePoseGraph_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SerializePoseGraph_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SerializePoseGraph_Request_TypeSupportInterface_var _var_type;

                static Sample_SerializePoseGraph_Request_TypeSupportInterface_ptr _duplicate (Sample_SerializePoseGraph_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SerializePoseGraph_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SerializePoseGraph_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SerializePoseGraph_Request_TypeSupportInterface () {};
                ~Sample_SerializePoseGraph_Request_TypeSupportInterface () {};
            private:
                Sample_SerializePoseGraph_Request_TypeSupportInterface (const Sample_SerializePoseGraph_Request_TypeSupportInterface &);
                Sample_SerializePoseGraph_Request_TypeSupportInterface & operator = (const Sample_SerializePoseGraph_Request_TypeSupportInterface &);
            };

            class  Sample_SerializePoseGraph_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SerializePoseGraph_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SerializePoseGraph_Request_DataWriter_var _var_type;

                static Sample_SerializePoseGraph_Request_DataWriter_ptr _duplicate (Sample_SerializePoseGraph_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SerializePoseGraph_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SerializePoseGraph_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SerializePoseGraph_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SerializePoseGraph_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SerializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SerializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SerializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SerializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SerializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SerializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SerializePoseGraph_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SerializePoseGraph_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SerializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SerializePoseGraph_Request_& instance_data) = 0;

            protected:
                Sample_SerializePoseGraph_Request_DataWriter () {};
                ~Sample_SerializePoseGraph_Request_DataWriter () {};
            private:
                Sample_SerializePoseGraph_Request_DataWriter (const Sample_SerializePoseGraph_Request_DataWriter &);
                Sample_SerializePoseGraph_Request_DataWriter & operator = (const Sample_SerializePoseGraph_Request_DataWriter &);
            };

            class  Sample_SerializePoseGraph_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SerializePoseGraph_Request_DataReader_ptr _ptr_type;
                typedef Sample_SerializePoseGraph_Request_DataReader_var _var_type;

                static Sample_SerializePoseGraph_Request_DataReader_ptr _duplicate (Sample_SerializePoseGraph_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SerializePoseGraph_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SerializePoseGraph_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SerializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SerializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SerializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SerializePoseGraph_Request_& instance) = 0;

            protected:
                Sample_SerializePoseGraph_Request_DataReader () {};
                ~Sample_SerializePoseGraph_Request_DataReader () {};
            private:
                Sample_SerializePoseGraph_Request_DataReader (const Sample_SerializePoseGraph_Request_DataReader &);
                Sample_SerializePoseGraph_Request_DataReader & operator = (const Sample_SerializePoseGraph_Request_DataReader &);
            };

            class  Sample_SerializePoseGraph_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SerializePoseGraph_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SerializePoseGraph_Request_DataReaderView_var _var_type;

                static Sample_SerializePoseGraph_Request_DataReaderView_ptr _duplicate (Sample_SerializePoseGraph_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SerializePoseGraph_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SerializePoseGraph_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SerializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SerializePoseGraph_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SerializePoseGraph_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SerializePoseGraph_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SerializePoseGraph_Request_& instance) = 0;

            protected:
                Sample_SerializePoseGraph_Request_DataReaderView () {};
                ~Sample_SerializePoseGraph_Request_DataReaderView () {};
            private:
                Sample_SerializePoseGraph_Request_DataReaderView (const Sample_SerializePoseGraph_Request_DataReaderView &);
                Sample_SerializePoseGraph_Request_DataReaderView & operator = (const Sample_SerializePoseGraph_Request_DataReaderView &);
            };
            class Sample_SerializePoseGraph_Response_TypeSupportInterface;

            typedef Sample_SerializePoseGraph_Response_TypeSupportInterface * Sample_SerializePoseGraph_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SerializePoseGraph_Response_TypeSupportInterface> Sample_SerializePoseGraph_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SerializePoseGraph_Response_TypeSupportInterface> Sample_SerializePoseGraph_Response_TypeSupportInterface_out;


            class Sample_SerializePoseGraph_Response_DataWriter;

            typedef Sample_SerializePoseGraph_Response_DataWriter * Sample_SerializePoseGraph_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SerializePoseGraph_Response_DataWriter> Sample_SerializePoseGraph_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SerializePoseGraph_Response_DataWriter> Sample_SerializePoseGraph_Response_DataWriter_out;


            class Sample_SerializePoseGraph_Response_DataReader;

            typedef Sample_SerializePoseGraph_Response_DataReader * Sample_SerializePoseGraph_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SerializePoseGraph_Response_DataReader> Sample_SerializePoseGraph_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SerializePoseGraph_Response_DataReader> Sample_SerializePoseGraph_Response_DataReader_out;


            class Sample_SerializePoseGraph_Response_DataReaderView;

            typedef Sample_SerializePoseGraph_Response_DataReaderView * Sample_SerializePoseGraph_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SerializePoseGraph_Response_DataReaderView> Sample_SerializePoseGraph_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SerializePoseGraph_Response_DataReaderView> Sample_SerializePoseGraph_Response_DataReaderView_out;

            struct Sample_SerializePoseGraph_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_SerializePoseGraph_Response_, struct Sample_SerializePoseGraph_Response_Seq_uniq_> Sample_SerializePoseGraph_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SerializePoseGraph_Response_Seq> Sample_SerializePoseGraph_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SerializePoseGraph_Response_Seq> Sample_SerializePoseGraph_Response_Seq_out;

            class  Sample_SerializePoseGraph_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SerializePoseGraph_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SerializePoseGraph_Response_TypeSupportInterface_var _var_type;

                static Sample_SerializePoseGraph_Response_TypeSupportInterface_ptr _duplicate (Sample_SerializePoseGraph_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SerializePoseGraph_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SerializePoseGraph_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SerializePoseGraph_Response_TypeSupportInterface () {};
                ~Sample_SerializePoseGraph_Response_TypeSupportInterface () {};
            private:
                Sample_SerializePoseGraph_Response_TypeSupportInterface (const Sample_SerializePoseGraph_Response_TypeSupportInterface &);
                Sample_SerializePoseGraph_Response_TypeSupportInterface & operator = (const Sample_SerializePoseGraph_Response_TypeSupportInterface &);
            };

            class  Sample_SerializePoseGraph_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SerializePoseGraph_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SerializePoseGraph_Response_DataWriter_var _var_type;

                static Sample_SerializePoseGraph_Response_DataWriter_ptr _duplicate (Sample_SerializePoseGraph_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SerializePoseGraph_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SerializePoseGraph_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SerializePoseGraph_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SerializePoseGraph_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SerializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SerializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SerializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SerializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SerializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SerializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SerializePoseGraph_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SerializePoseGraph_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SerializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SerializePoseGraph_Response_& instance_data) = 0;

            protected:
                Sample_SerializePoseGraph_Response_DataWriter () {};
                ~Sample_SerializePoseGraph_Response_DataWriter () {};
            private:
                Sample_SerializePoseGraph_Response_DataWriter (const Sample_SerializePoseGraph_Response_DataWriter &);
                Sample_SerializePoseGraph_Response_DataWriter & operator = (const Sample_SerializePoseGraph_Response_DataWriter &);
            };

            class  Sample_SerializePoseGraph_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SerializePoseGraph_Response_DataReader_ptr _ptr_type;
                typedef Sample_SerializePoseGraph_Response_DataReader_var _var_type;

                static Sample_SerializePoseGraph_Response_DataReader_ptr _duplicate (Sample_SerializePoseGraph_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SerializePoseGraph_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SerializePoseGraph_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SerializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SerializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SerializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SerializePoseGraph_Response_& instance) = 0;

            protected:
                Sample_SerializePoseGraph_Response_DataReader () {};
                ~Sample_SerializePoseGraph_Response_DataReader () {};
            private:
                Sample_SerializePoseGraph_Response_DataReader (const Sample_SerializePoseGraph_Response_DataReader &);
                Sample_SerializePoseGraph_Response_DataReader & operator = (const Sample_SerializePoseGraph_Response_DataReader &);
            };

            class  Sample_SerializePoseGraph_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SerializePoseGraph_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SerializePoseGraph_Response_DataReaderView_var _var_type;

                static Sample_SerializePoseGraph_Response_DataReaderView_ptr _duplicate (Sample_SerializePoseGraph_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SerializePoseGraph_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SerializePoseGraph_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SerializePoseGraph_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SerializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SerializePoseGraph_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SerializePoseGraph_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SerializePoseGraph_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SerializePoseGraph_Response_& instance) = 0;

            protected:
                Sample_SerializePoseGraph_Response_DataReaderView () {};
                ~Sample_SerializePoseGraph_Response_DataReaderView () {};
            private:
                Sample_SerializePoseGraph_Response_DataReaderView (const Sample_SerializePoseGraph_Response_DataReaderView &);
                Sample_SerializePoseGraph_Response_DataReaderView & operator = (const Sample_SerializePoseGraph_Response_DataReaderView &);
            };
        }

    }

}

#endif
